diff a/src/hotspot/share/runtime/globals.hpp b/src/hotspot/share/runtime/globals.hpp
--- a/src/hotspot/share/runtime/globals.hpp
+++ b/src/hotspot/share/runtime/globals.hpp
@@ -2491,10 +2491,20 @@
                "(Deprecated) Use new algorithm to compute field layouts")   \
                                                                             \
   product(bool, UseEmptySlotsInSupers, true,                                \
                 "Allow allocating fields in empty slots of super-classes")  \
                                                                             \
+  TSAN_ONLY(product(bool, ThreadSanitizer, false,                           \
+          "Enable ThreadSanitizer lock instrumentation"))                   \
+                                                                            \
+  TSAN_ONLY(product(bool, ThreadSanitizerJavaMemory, true,                  \
+          "Detect Java data races with ThreadSanitizer. "                   \
+          "This is only enabled if -XX:+ThreadSanitizer is set."))          \
+                                                                            \
+  TSAN_ONLY(product(ccstr, ThreadSanitizerIgnoreFile, NULL,                 \
+          "File containing a list of ignored field patterns for "           \
+          "ThreadSanitizer."))                                              \
 
 
 // Interface macros
 #define DECLARE_PRODUCT_FLAG(type, name, value, doc)      extern "C" type name;
 #define DECLARE_PD_PRODUCT_FLAG(type, name, doc)          extern "C" type name;
